﻿using System;
using System.Collections.Generic;
using System.Text;
using zcompiler;

namespace zcompiler {
    class Parser {

        private int index;
        private IList<object> tokens;

        private readonly AST.Stmt result;
        public AST.Stmt Result {
            get { return result; }
        }

        //Default constructor
        public Parser(IList<object> Tokens) {

            //Set our values
            this.tokens = Tokens;
            this.index = 0;

            //Return the parsed statement
            this.result = this.ParseStmt();
            
            //Check for EOF
            if (this.index != this.tokens.Count)
                throw new Exception("EOF expected.");
        }

        private AST.Stmt ParseStmt() { 
        

        
        }

        private AST.Expr ParseExpr() {

            //Check if we've reached the end of the tokens, first
            if (this.index == this.tokens.Count)
                throw new Exception("EOF has been found, however an expression is expected.");

            //If the data is a raw string, i.e. we didn't do
            //<type>.Parse() or data.ToString()
            if (this.tokens[this.index] is StringBuilder) {

                //Get that string
                string value = ((StringBuilder)this.tokens[this.index++]).ToString();
                //Create a new Zenon string
                AST.String str = new AST.String();
                //Set the Zenon string's value
                str.Value = value;
                //Return that string
                return str;

            }
            //If the data is an integer
            else if (this.tokens[this.index] is int) {

                //Get that integer
                int value = (int)this.tokens[this.index++];
                //Create a new Zenon integer
                AST.Integer anInt = new AST.Integer();
                //Set it's value
                anInt.Value = value;
                //Return it
                return anInt;

            }
            //If the data is a variable name or keyword
            else if (this.tokens[this.index] is string) {

                //Get the variable
                string identity = (string)this.tokens[this.index++];
                //Create a new Zenon var
                AST.Variable var = new AST.Variable();
                //Get its identity
                var.Ident = identity;
                //Return it
                return var;

            }
            //If the data is a byte
            else if (this.tokens[this.index] is byte) {

                //Get that byte
                byte value = (byte)this.tokens[this.index++];
                //Create a new Zenon byte
                AST.Byte zbyte = new AST.Byte();
                //Store the value
                zbyte.Value = value;
                //Return it
                return zbyte;

            }
            //If the data is a Boolean value
            else if (this.tokens[this.index] is bool) {

                //Get that bool
                bool value = (bool)this.tokens[this.index++];
                //Create a Zenon bool
                AST.Boolean zbool = new AST.Boolean();
                //Set its value
                zbool.Value = value;
                //Return it
                return zbool;
            
            }
            else
                throw new Exception("Expected string, int, byte, bool, or variable.");
        
        }

    }
}
