﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Threading;

namespace zcompiler {
    class Program {

        /*
         * TODO:
         * -Expand on errors to include token and/or index
         * 
         */

        static void Main(string[] args) {
            Console.Title = "Zenon Compiler";

            string[] header = new string[] {
            @"/-----------------------------------------------------------------------------\",
            @"]                          ==/ === |\  | /==\ |\  |                           [",
            @"]                           /  ==  | \ | |  | | \ |                           [",
            @"]                          /== === |  \| \==/ |  \|                           [",
            @"]                                                                             [",
            @"]                 A .NET LANGUAGE BY BLAKPILAR & BINDER NEWS                  [",
            @"\-----------------------------------------------------------------------------/",
            @" |                                                                           | ",
            };

            //Display the header
            foreach (string str in header)
                Console.WriteLine(str);

            //If the console the app had file(s) dragged on it
            if (args.Length != 0)
            {
                //Show the "Compile" user interface
                UI.Compile compUI = new UI.Compile(args);
                compUI.Begin();
            }
            //If the app was just opened
            else {
                //Show the "Opened" user interface
                UI.Opened openUI = new UI.Opened();
                openUI.Show();
            }
        }
    }

    public class UI {

        //Called when the program is simply opened
        public class Opened {

            public void Show() {

                //Show the commands
                this.ShowCommands();

                string input = "";
                while (true) {

                    input = this.Input();
                    Console.WriteLine();

                    //If the user typed '/exit', then do so
                    //NOTE: for some reason, putting these in the condition
                    //      of the loop didn't work
                    if (input == "/exit")
                        break;
                    else if (input == "/credits")
                        this.ShowCredits();
                    else if (input == "/help")
                        this.ShowHelp();
                    else if (input == "/commands")
                        this.ShowCommands();
                    else if (input.StartsWith("/check "))
                        this.CheckFile(input.Substring(6, input.Length - 7));
                    //If the user wants to compile a file
                    else if (input.StartsWith("/compile "))
                    {

                        //Begin compiling
                        Compile comp = new Compile(
                            new string[] { input.Substring(8, input.Length - 9) });
                        comp.Begin();
                        break;

                    }
                    else
                        Console.WriteLine(String.Format("Unknown command '{0}'\n", input));

                }
            }

            private void ShowCommands() {

                string[] commands = new string[] { 
                @"/-----------------------------------------------------------------------------\",
                @"]Commands:                                                                    [",
                @"]/help                : shows the help                                        [",
                @"]/commands            : shows this list of commands                           [",
                @"]/credits             : shows the credits for the compiler'                   [",
                @"]/compile <file path> : compiles the specified file                           [",
                @"]/check <file path>   : checks the specified file for errors                  [",
                @"]/exit                : exits the program                                     [",
                @"\-----------------------------------------------------------------------------/",
                "",
                };

                foreach (string str in commands)
                    Console.WriteLine(str);

            }

            private void ShowCredits() {

                string[] credits = new string[] { 
                @"Developers",
                @" :BlakPilar",
                @" :Binder News",
                @"Special thanks (in no special order)",
                @" :Ashbad",
                @" :HOMER-16",
                @" :t0xic_kitt3n",
                @" :Spyro543",
                @" :jkag",
                @" :Broseph Radson",
                @" :Everyone else at Omnimaga",
                @" :Joel Pobar",
                @" :You",
                };

                foreach (string str in credits)
                    Console.WriteLine(str);
            
            }

            private void ShowHelp() {

                Console.WriteLine("Seriously, what don't you understand?\n");
            
            }

            private string Input() {
                return Console.ReadLine();
            }

            private void CheckFile(string path) {

                if (path == "") {
                    Console.WriteLine("Path cannot be null.\n");
                    return;
                }

            }
        }

        //Called when the program has a file dragged on it
        public class Compile {
            private string[] args;

            public Compile(string[] Args) {
                this.args = Args;
            }

            public void Begin() { 
            

            
            }
        }
    }
}
